Loading...
Searching...
No Matches
Opm::WetGasPvt< Scalar > Class Template Reference

This class represents the Pressure-Volume-Temperature relations of the gas phas with vaporized oil. More...

`#include <WetGasPvt.hpp>`

## Public Types

using | TabulatedTwoDFunction = UniformXTabulated2DFunction<Scalar>
using | TabulatedOneDFunction = Tabulated1DFunction<Scalar>

## Public Member Functions

void | setNumRegions (std::size_t numRegions)
void | setVapPars (const Scalar par1, const Scalar)
void | setReferenceDensities (unsigned regionIdx, Scalar rhoRefOil, Scalar rhoRefGas, Scalar)
| Initialize the reference densities of all fluids for a given PVT region.
void | setSaturatedGasOilVaporizationFactor (unsigned regionIdx, const SamplingPoints &samplePoints)
| Initialize the function for the oil vaporization factor .
void | setSaturatedGasFormationVolumeFactor (unsigned regionIdx, const SamplingPoints &samplePoints)
| Initialize the function for the gas formation volume factor.
void | setInverseGasFormationVolumeFactor (unsigned regionIdx, const TabulatedTwoDFunction &invBg)
| Initialize the function for the gas formation volume factor.
void | setGasViscosity (unsigned regionIdx, const TabulatedTwoDFunction &mug)
| Initialize the viscosity of the gas phase.
void | setSaturatedGasViscosity (unsigned regionIdx, const SamplingPoints &samplePoints)
| Initialize the phase viscosity for oil saturated gas.
void | initEnd ()
| Finish initializing the gas phase PVT properties.
unsigned | numRegions () const
| Return the number of PVT regions which are considered by this PVT-object.
template<class Evaluation>
Evaluation | internalEnergy (unsigned, const Evaluation &, const Evaluation &, const Evaluation &, const Evaluation &) const
| Returns the specific enthalpy [J/kg] of gas given a set of parameters.
Scalar | hVap (unsigned) const
template<class Evaluation>
Evaluation | viscosity (unsigned regionIdx, const Evaluation &, const Evaluation &pressure, const Evaluation &Rv, const Evaluation &) const
| Returns the dynamic viscosity [Pa s] of the fluid phase given a set of parameters.
template<class Evaluation>
Evaluation | saturatedViscosity (unsigned regionIdx, const Evaluation &, const Evaluation &pressure) const
| Returns the dynamic viscosity [Pa s] of oil saturated gas at a given pressure.
template<class Evaluation>
Evaluation | inverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &, const Evaluation &pressure, const Evaluation &Rv, const Evaluation &) const
| Returns the formation volume factor [-] of the fluid phase.
template<class FluidState, class LhsEval = typename FluidState::Scalar>
std::pair< LhsEval, LhsEval > | inverseFormationVolumeFactorAndViscosity (const FluidState &fluidState, unsigned regionIdx)
| Returns the formation volume factor [-] and viscosity [Pa s] of the fluid phase.
template<class Evaluation>
Evaluation | saturatedInverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &, const Evaluation &pressure) const
| Returns the formation volume factor [-] of oil saturated gas at a given pressure.
template<class Evaluation>
Evaluation | saturatedWaterVaporizationFactor (unsigned, const Evaluation &, const Evaluation &) const
| Returns the water vaporization factor [m^3/m^3] of the gasphase.
template<class Evaluation = Scalar>
Evaluation | saturatedWaterVaporizationFactor (unsigned, const Evaluation &, const Evaluation &, const Evaluation &) const
| Returns the water vaporization factor [m^3/m^3] of water saturated gas.
template<class Evaluation>
Evaluation | saturatedOilVaporizationFactor (unsigned regionIdx, const Evaluation &, const Evaluation &pressure) const
| Returns the oil vaporization factor [m^3/m^3] of the gas phase.
template<class Evaluation>
Evaluation | saturatedOilVaporizationFactor (unsigned regionIdx, const Evaluation &, const Evaluation &pressure, const Evaluation &oilSaturation, Evaluation maxOilSaturation) const
| Returns the oil vaporization factor [m^3/m^3] of the gas phase.
template<class Evaluation>
Evaluation | saturationPressure (unsigned regionIdx, const Evaluation &, const Evaluation &Rv) const
| Returns the saturation pressure of the gas phase [Pa] depending on its mass fraction of the oil component.
template<class Evaluation>
Evaluation | diffusionCoefficient (const Evaluation &, const Evaluation &, unsigned) const
Scalar | gasReferenceDensity (unsigned regionIdx) const
Scalar | oilReferenceDensity (unsigned regionIdx) const
const std::vector< TabulatedTwoDFunction > & | inverseGasB () const
const std::vector< TabulatedOneDFunction > & | inverseSaturatedGasB () const
const std::vector< TabulatedTwoDFunction > & | gasMu () const
const std::vector< TabulatedTwoDFunction > & | inverseGasBMu () const
const std::vector< TabulatedOneDFunction > & | inverseSaturatedGasBMu () const
const std::vector< TabulatedOneDFunction > & | saturatedOilVaporizationFactorTable () const
const std::vector< TabulatedOneDFunction > & | saturationPressure () const
Scalar | vapPar1 () const

## Detailed Description

template<class Scalar>
class Opm::WetGasPvt< Scalar >

This class represents the Pressure-Volume-Temperature relations of the gas phas with vaporized oil.

## Member Function Documentation

## saturatedOilVaporizationFactor()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::WetGasPvt< Scalar >::saturatedOilVaporizationFactor | ( | unsigned | regionIdx,
|  | const Evaluation & | ,
|  | const Evaluation & | pressure,
|  | const Evaluation & | oilSaturation,
|  | Evaluation | maxOilSaturation ) const

inline

Returns the oil vaporization factor [m^3/m^3] of the gas phase.

This variant of the method prevents all the oil to be vaporized even if the gas phase is still not saturated. This is physically quite dubious but it corresponds to how the Eclipse 100 simulator handles this. (cf the VAPPARS keyword.)

## saturationPressure()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::WetGasPvt< Scalar >::saturationPressure | ( | unsigned | regionIdx,
|  | const Evaluation & | ,
|  | const Evaluation & | Rv ) const

inline

Returns the saturation pressure of the gas phase [Pa] depending on its mass fraction of the oil component.

This method uses the standard blackoil assumptions: This means that the Rv value does not depend on the saturation of oil. (cf. the Eclipse VAPPARS keyword.)

Parameters

  regionIdx | Region index to use
  Rv | The surface volume of oil component dissolved in what will yield one cubic meter of gas at the surface [-]

## setGasViscosity()

template<class Scalar>

void Opm::WetGasPvt< Scalar >::setGasViscosity | ( | unsigned | regionIdx,
|  | const TabulatedTwoDFunction & | mug )

inline

Initialize the viscosity of the gas phase.

This is a function of ...

## setInverseGasFormationVolumeFactor()

template<class Scalar>

void Opm::WetGasPvt< Scalar >::setInverseGasFormationVolumeFactor | ( | unsigned | regionIdx,
|  | const TabulatedTwoDFunction & | invBg )

inline

Initialize the function for the gas formation volume factor.

The gas formation volume factor is a function of and represents the partial density of the oil component in the gas phase at a given pressure.

This method sets . Note that instead of the mass fraction of the oil component in the gas phase, this function depends on the gas dissolution factor. Also note, that the order of the arguments needs to be and not the other way around.

## setSaturatedGasFormationVolumeFactor()

template<class Scalar>

void Opm::WetGasPvt< Scalar >::setSaturatedGasFormationVolumeFactor | ( | unsigned | regionIdx,
|  | const SamplingPoints & | samplePoints )

Initialize the function for the gas formation volume factor.

The gas formation volume factor is a function of and represents the partial density of the oil component in the gas phase at a given pressure. This method only requires the volume factor of oil-saturated gas (which only depends on pressure) while the dependence on the oil mass fraction is guesstimated...

## setSaturatedGasOilVaporizationFactor()

template<class Scalar>

void Opm::WetGasPvt< Scalar >::setSaturatedGasOilVaporizationFactor | ( | unsigned | regionIdx,
|  | const SamplingPoints & | samplePoints )

inline

Initialize the function for the oil vaporization factor .

Parameters

  regionIdx | Region index to use
  samplePoints | A container of (x,y) values.

## setSaturatedGasViscosity()

template<class Scalar>

void Opm::WetGasPvt< Scalar >::setSaturatedGasViscosity | ( | unsigned | regionIdx,
|  | const SamplingPoints & | samplePoints )

Initialize the phase viscosity for oil saturated gas.

The gas viscosity is a function of , but this method only requires the viscosity of oil-saturated gas (which only depends on pressure) while there is assumed to be no dependence on the gas mass fraction...

The documentation for this class was generated from the following files:

- opm/material/fluidsystems/blackoilpvt/WetGasPvt.hpp
- opm/material/fluidsystems/blackoilpvt/WetGasPvt.cpp